import java.io.InputStream;

import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.AlertType;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Display;

import lancs.mobilemedia.core.ui.datamodel.MediaData;
import lancs.mobilemedia.core.ui.datamodel.VideoAlbumData;
import lancs.mobilemedia.core.ui.screens.AlbumListScreen;
import lancs.mobilemedia.core.ui.screens.MediaListScreen;
import lancs.mobilemedia.core.ui.screens.PlayVideoScreen;
import lancs.mobilemedia.lib.exceptions.ImageNotFoundException;
import lancs.mobilemedia.lib.exceptions.PersistenceMechanismException;

class MediaController {
	public boolean handleCommand(Command command) {
		boolean handled = original(command);
		if (handled)
			return true;
		String label = command.getLabel();
		if (label.equals("Play Video")) {
			String selectedMediaName = getSelectedMediaName();
			return playVideoMedia(selectedMediaName);
		}
		return false;
	}

	private void prepareController(PlayVideoController controller, String name) {
		// nothing to do
	}

	private boolean playVideoMedia(String selectedMediaName) {
		InputStream storedMusic = null;
		try {
			MediaData mymedia = getAlbumData().getMediaInfo(selectedMediaName);

			// if (mymedia instanceof MultiMediaData) {
			if (mymedia.getTypeMedia().equals(MediaData.VIDEO)) {
				storedMusic = ((VideoAlbumData) getAlbumData())
						.getVideoFromRecordStore(getCurrentStoreName(),
								selectedMediaName);
				PlayVideoScreen playscree = new PlayVideoScreen(midlet,
						storedMusic, mymedia.getTypeMedia(), this);
				playscree.setVisibleVideo();
				PlayVideoController controller = new PlayVideoController(
						midlet, getAlbumData(),
						(AlbumListScreen) getAlbumListScreen(), playscree);
				prepareController(controller, selectedMediaName);

				this.setNextController(controller);
			}
			return true;
		} catch (ImageNotFoundException e) {
			Alert alert = new Alert("Error",
					"The selected item was not found in the mobile device",
					null, AlertType.ERROR);
			Display.getDisplay(midlet).setCurrent(alert,
					Display.getDisplay(midlet).getCurrent());
			return false;
		} catch (PersistenceMechanismException e) {
			Alert alert = new Alert("Error",
					"The mobile database can open this item 1", null,
					AlertType.ERROR);
			Display.getDisplay(midlet).setCurrent(alert,
					Display.getDisplay(midlet).getCurrent());
			return false;
		}
	}
}
